poj2288 Islands and Bridges 状态压缩dp

97 篇文章 0 订阅
6 篇文章 0 订阅
J - Islands and Bridges
Time Limit:4000MS     Memory Limit:65536KB     64bit IO Format:%I64d & %I64u

Description

Given a map of islands and bridges that connect these islands, a Hamilton path, as we all know, is a path along the bridges such that it visits each island exactly once. On our map, there is also a positive integer value associated with each island. We call a Hamilton path the best triangular Hamilton path if it maximizes the value described below.  

Suppose there are n islands. The value of a Hamilton path C1C2...Cn is calculated as the sum of three parts. Let Vi be the value for the island Ci. As the first part, we sum over all the Vi values for each island in the path. For the second part, for each edge CiC i+1  in the path, we add the product Vi*V i+1. And for the third part, whenever three consecutive islands CiC i+1C i+2  in the path forms a triangle in the map, i.e. there is a bridge between Ci and C i+2, we add the product Vi*V i+1*V i+2.  

Most likely but not necessarily, the best triangular Hamilton path you are going to find contains many triangles. It is quite possible that there might be more than one best triangular Hamilton paths; your second task is to find the number of such paths.  

Input

The input file starts with a number q (q<=20) on the first line, which is the number of test cases. Each test case starts with a line with two integers n and m, which are the number of islands and the number of bridges in the map, respectively. The next line contains n positive integers, the i-th number being the Vi value of island i. Each value is no more than 100. The following m lines are in the form x y, which indicates there is a (two way) bridge between island x and island y. Islands are numbered from 1 to n. You may assume there will be no more than 13 islands.  

Output

For each test case, output a line with two numbers, separated by a space. The first number is the maximum value of a best triangular Hamilton path; the second number should be the number of different best triangular Hamilton paths. If the test case does not contain a Hamilton path, the output must be `0 0'.  

Note: A path may be written down in the reversed order. We still think it is the same path.

Sample Input

2
3 3
2 2 2
1 2
2 3
3 1
4 6
1 2 3 4
1 2
1 3
1 4
2 3
2 4
3 4

Sample Output

22 3
69 1
好题 ,从这道才可以说是入门DP了吧,这题要注意是1的时候输出1,而且,要用int64,这里,错了好几次,
分析题目,壮态压缩,也就是用二进制来记录每个结点访问的次数,也就是dp的第一维记下来的,这样用二进制,也方便很多,但这不是难点,主要是要判是否形成三角形,这一点,就要记录,最后两个结点就可以了,因为,在加入新结点的时候,只有最后两个结点才是有作用的,这一点也是想了很长时间才明白的,此外就是一个普通DP,就很简单了!要注意,结点,在最后要除以二,因为题目说了顺序不同,算一个!
dp[staus][second][last] 表示状态为staus(二进制位是否为1表示是否走过),最后两个点为last,second两个点,
最后两个点就是为了看是否组成三角形用的,枚举第三条边进行更新就可以了!总的复杂度为o(2^k * n ^ 3);状态总数有
2^k * n * n个,加上每个状态转移有n个。具体看代码
<pre name="code" class="cpp">int n,m,v[15],mymap[15][15];
__int64 waynum[10000][15][15];
__int64 dp[10000][15][15];
__int64 fmin(__int64 a,__int64 b){if(a<b)return a;return b;};
void init()
{
    int i,s,e,j,state;
    __int64 valstate;
    memset(mymap,-1,sizeof(mymap));
    memset(dp,-1,sizeof(dp));
    memset(waynum,0,sizeof(waynum));
    memset(v,0,sizeof(v));
    for(i=0;i<n;i++)
        scanf("%d",&v[i]);
    for(i=0;i<m;i++)
    {
        scanf("%d%d",&s,&e);
        s--;e--;//都从0开始
        mymap[s][e]=mymap[e][s]=1;
    }
    for(i=0;i<n;i++)
    {
        for(j=0;j<n;j++)
        {
            if((i!=j)&&(mymap[i][j]!=-1))//i和j之间是相连通的且不是同一点 
            {
                state=(1<<i)+(1<<j);
                valstate=v[i]+v[j]+v[i]*v[j];
                dp[state][i][j]=valstate;//初始化dp为一条边相连的壮态
                waynum[state][i][j]=1;//相应壮态路的条数
            }
        }
    }
}
int makedp()
{
    int i,state,allnum,j,k;
    __int64 maxx,tempval,cnt;
    allnum=1<<n;
    for(state=0;state<allnum;state++)
    {
        for(i=0;i<n;i++)//最后第二位
        if(state&(1<<i))
        {
            for(j=0;j<n;j++)//倒第一位
            {
              if((i!=j)&&(state&(1<<j))&&(dp[state][i][j]>=0))//必须从有意义的开始
              {
                for(k=0;k<n;k++)
               {
                   if(((j!=k)&&((state&(1<<k))==0)&&(mymap[j][k]!=-1)))//k未访问且k与最后一边相连
                      {
                          if(mymap[i][k]!=-1)//倒第二个点,也相连,构成了三角形
                          {
                             tempval=dp[state][i][j]+v[k]+v[j]*v[k]+v[i]*v[j]*v[k];
                          }
                          else
                          {
                           tempval=dp[state][i][j]+v[k]+v[j]*v[k];
                          }
                           if(tempval>dp[state|(1<<k)][j][k])
                            {
                                dp[state|(1<<k)][j][k]=tempval;
                                waynum[state|(1<<k)][j][k]= waynum[state][i][j];
                            }
                            else if(tempval==dp[state|(1<<k)][j][k])
                            {
                               waynum[state|(1<<k)][j][k]+=waynum[state][i][j];//注意壮态的先后关系
                            }
                    }
                }
              }
            }
        }
    }
    maxx=-1;cnt=0;
    i=(1<<n)-1;//壮态必须是全都经过了一次
    for(j=0;j<n;j++)
        for(k=0;k<n;k++)
        {
           // printf("%I64d %I64d \n",maxx,dp[i][j][k]);
            if(i!=j&&dp[i][j][k]!=-1)
            {
                if(dp[i][j][k]>maxx)
                {
                    maxx=dp[i][j][k];
                    cnt=waynum[i][j][k];//结点更新成最大值
                }
                else if(dp[i][j][k]==maxx)//如果和最大值相等,就把点加起来
                {
                    cnt+=waynum[i][j][k];
                }
            }
        }
	if(maxx!=-1)//有回路
        printf("%I64d %I64d\n",maxx,cnt/2);
	else
		printf("0 0\n");
    return 1;
}
int main()
{
    int tcase;
    scanf("%d",&tcase);
    while(tcase--)
    {
        scanf("%d%d",&n,&m);
        init();
        if(n!=1)
            makedp();
        else
        {
            printf("%d 1\n",v[0]);//一个结点就直接输出
        }
    }
    return 0;
}


 
  
  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
题目描述 给出一个$n\times m$的矩阵,每个位置上有一个非负整数,代表这个位置的海拔高度。一开始时,有一个人站在其中一个位置上。这个人可以向上、下、左、右四个方向移动,但是只能移动到海拔高度比当前位置低或者相等的位置上。一次移动只能移动一个单位长度。定义一个位置为“山顶”,当且仅当从这个位置开始移动,可以一直走到海拔高度比它低的位置上。请问,这个矩阵中最多有多少个“山顶”? 输入格式 第一行两个整数,分别表示$n$和$m$。 接下来$n$行,每行$m$个整数,表示整个矩阵。 输出格式 输出一个整数,表示最多有多少个“山顶”。 样例输入 4 4 3 2 1 4 2 3 4 3 5 6 7 8 4 5 6 7 样例输出 5 算法1 (递归dp) $O(nm)$ 对于这道题,我们可以使用递归DP来解决,用$f(i,j)$表示以$(i,j)$为起点的路径最大长度,那么最后的答案就是所有$f(i,j)$中的最大值。 状态转移方程如下: $$ f(i,j)=\max f(x,y)+1(x,y)是(i,j)的下一个满足条件的位置 $$ 注意:这里的状态转移方程中的$x,y$是在枚举四个方向时得到的下一个位置,即: - 向上:$(i-1,j)$ - 向下:$(i+1,j)$ - 向左:$(i,j-1)$ - 向右:$(i,j+1)$ 实现过程中需要注意以下几点: - 每个点都需要搜一遍,因此需要用双重for循环来枚举每个起点; - 对于已经搜索过的点,需要用一个数组$vis$来记录,防止重复搜索; - 在进行状态转移时,需要判断移动后的点是否满足条件。 时间复杂度 状态数为$O(nm)$,每个状态转移的时间复杂度为$O(1)$,因此总时间复杂度为$O(nm)$。 参考文献 C++ 代码 算法2 (动态规划) $O(nm)$ 动态规划的思路与递归DP类似,只不过转移方程和实现方式有所不同。 状态转移方程如下: $$ f(i,j)=\max f(x,y)+1(x,y)是(i,j)的下一个满足条件的位置 $$ 注意:这里的状态转移方程中的$x,y$是在枚举四个方向时得到的下一个位置,即: - 向上:$(i-1,j)$ - 向下:$(i+1,j)$ - 向左:$(i,j-1)$ - 向右:$(i,j+1)$ 实现过程中需要注意以下几点: - 每个点都需要搜一遍,因此需要用双重for循环来枚举每个起点; - 对于已经搜索过的点,需要用一个数组$vis$来记录,防止重复搜索; - 在进行状态转移时,需要判断移动后的点是否满足条件。 时间复杂度 状态数为$O(nm)$,每个状态转移的时间复杂度为$O(1)$,因此总时间复杂度为$O(nm)$。 参考文献 C++ 代码

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值